"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const fs_extra_1 = tslib_1.__importDefault(require("fs-extra"));
const constant_1 = tslib_1.__importDefault(require("../config/constant"));
const Application_1 = require("../libs/Application");
class Config extends Application_1.JKUtil {
    constructor() {
        super();
        this._config = "{}";
        this.load();
    }
    get config() {
        return JSON.parse(this._config || "{}");
    }
    load() {
        try {
            this._config = fs_extra_1.default.readFileSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_CONFIG).toString();
        }
        catch (error) {
            fs_extra_1.default.ensureDirSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_ROOT);
            fs_extra_1.default.writeFileSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_CONFIG, "");
        }
    }
    /**
     * save
     */
    save(key, value) {
        return new Promise((resolve) => {
            const doc = JSON.stringify(Object.assign(Object.assign({}, this.config), { [key]: value }));
            fs_extra_1.default.writeFileSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_CONFIG, doc);
            this._config = doc;
            resolve(true);
        });
    }
    /**
     * get
     */
    get(key) {
        return this.config[key];
    }
    /**
     * clear
     */
    clear() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            fs_extra_1.default.writeFileSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_CONFIG, "{}");
            this._config = "{}";
        });
    }
}
exports.default = Config;
