"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ora_1 = tslib_1.__importDefault(require("ora"));
const Application_1 = require("../libs/Application");
class Loading extends Application_1.JKUtil {
    start(message = "loading") {
        this.spinner = ora_1.default(message).start();
    }
    /**
     * text
     */
    text(message = "loading") {
        if (!this.spinner) {
            this.start(message);
        }
        else {
            this.spinner.text = message;
        }
    }
    /**
     * color
     */
    color(color = "white") {
        if (!this.spinner) {
            this.start();
        }
        this.spinner.color = color;
    }
    /**
     * property
     */
    property(message, color) {
        this.text(message);
        this.color(color);
    }
    /**
     * stop
     */
    stop() {
        var _a;
        (_a = this.spinner) === null || _a === void 0 ? void 0 : _a.stop();
    }
}
exports.default = Loading;
