"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/* eslint-disable @typescript-eslint/no-empty-function */
/* eslint-disable no-async-promise-executor */
/* eslint-disable prefer-const */
const chalk_1 = tslib_1.__importDefault(require("chalk"));
const cors_1 = tslib_1.__importDefault(require("cors"));
const express_1 = tslib_1.__importDefault(require("express"));
const open_1 = tslib_1.__importDefault(require("open"));
const constant_1 = tslib_1.__importDefault(require("../config/constant"));
const Application_1 = require("../libs/Application");
const loginUrl = () => {
    const CLIENT_ID = "Iv1.f92a3890970ecc1e";
    const CLIENT_SECRET = "d6ae5fbd1189ea0577b2a1b01ba0d3b902e6f3cc";
    const url = `https://github.com/login/oauth/authorize?client_id=${CLIENT_ID}&client_secret=${CLIENT_SECRET}`;
    return url;
};
class Login extends Application_1.JKUtil {
    setTimer() {
        this.timer = setTimeout(() => {
            console.log(chalk_1.default.white(`If it is not opened with the default browser, please copy the link to access`));
            console.log();
            console.log(chalk_1.default.blue(loginUrl()));
            console.log();
        }, 10000);
    }
    confirm() {
        var _a, _b;
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            clearTimeout(this.timer);
            try {
                yield ((_b = (_a = this.ctx) === null || _a === void 0 ? void 0 : _a.Form) === null || _b === void 0 ? void 0 : _b.confirm("Are you sure you want to login again?"));
                yield this.action();
            }
            catch (error) { }
        });
    }
    logout() {
        var _a, _b;
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            clearTimeout(this.timer);
            yield ((_b = (_a = this.ctx) === null || _a === void 0 ? void 0 : _a.Token) === null || _b === void 0 ? void 0 : _b.save(""));
            console.log(chalk_1.default.green("logout success"));
        });
    }
    action() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                let server;
                const app = express_1.default();
                app.use(cors_1.default({
                    origin: "https://www.jikequan.net",
                    credentials: true,
                }));
                app.get("/oauth", (req, res) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                    var _a, _b, _c, _d, _e, _f, _g;
                    clearTimeout(this.timer);
                    yield ((_b = (_a = this.ctx) === null || _a === void 0 ? void 0 : _a.Token) === null || _b === void 0 ? void 0 : _b.save((_c = req.query) === null || _c === void 0 ? void 0 : _c.token));
                    try {
                        const user = yield ((_e = (_d = this.ctx) === null || _d === void 0 ? void 0 : _d.Api) === null || _e === void 0 ? void 0 : _e.user());
                        if (!user) {
                            throw new Error("user not found");
                        }
                        yield ((_g = (_f = this.ctx) === null || _f === void 0 ? void 0 : _f.User) === null || _g === void 0 ? void 0 : _g.save(JSON.stringify(user)));
                        console.log(chalk_1.default.green(`login success: ${chalk_1.default.blue(user === null || user === void 0 ? void 0 : user.login)}`));
                        res.end(JSON.stringify({ code: 0, data: "success" }));
                        resolve({ code: 0, data: "success" });
                    }
                    catch (error) {
                        console.log(chalk_1.default.red(`login failed: ${error}`));
                        res.end(JSON.stringify({ code: -1, data: "fail" }));
                        reject({ code: -1, data: "fail" });
                    }
                    server === null || server === void 0 ? void 0 : server.close(function () { });
                }));
                server = yield app.listen(constant_1.default.AUTH_PORT);
                console.log(chalk_1.default.green("wait for authorize by github account"));
                open_1.default(loginUrl());
                this.setTimer();
            }));
        });
    }
}
exports.default = Login;
