"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const Application_1 = require("../libs/Application");
const fs_extra_1 = tslib_1.__importDefault(require("fs-extra"));
const path_1 = tslib_1.__importDefault(require("path"));
const { Worker } = require("worker_threads");
class Step extends Application_1.JKUtil {
    constructor() {
        super(...arguments);
        this.formTypes = ["confirm", "input", "list", "edit"];
    }
    /**
     * Lists
     */
    lists() {
        var _a, _b;
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            try {
                const { data = [] } = yield ((_b = (_a = this.ctx) === null || _a === void 0 ? void 0 : _a.Api) === null || _b === void 0 ? void 0 : _b.fragments());
                return data;
            }
            catch (err) {
                return [];
            }
        });
    }
    /**
     * start
     */
    start() {
        var _a, _b;
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const lists = yield this.lists();
            const name = yield ((_b = (_a = this.ctx) === null || _a === void 0 ? void 0 : _a.Form) === null || _b === void 0 ? void 0 : _b.list({ choices: lists.map((l) => l.name) }));
            const current = lists.filter((l) => l.name === name);
            this.exectorStep(current[0]);
        });
    }
    /**
     * exectorStep
     */
    exectorStep(current) {
        var _a;
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            if (!current) {
                return;
            }
            const res = {};
            for (let j = 0; j < current.steps.length; j++) {
                const step = current.steps[j];
                if (this.formTypes.includes(step.type)) {
                    const name = yield ((_a = this.ctx) === null || _a === void 0 ? void 0 : _a.Form)[step.type]({ message: step.describe });
                    res[step.field] = name;
                }
                else if (step.type === "create") {
                    step === null || step === void 0 ? void 0 : step.files.map((file) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                        var _b, _c, _d, _e, _f, _g, _h, _j;
                        const a = (_e = (_d = (_c = (_b = this.ctx) === null || _b === void 0 ? void 0 : _b.Template) === null || _c === void 0 ? void 0 : _c.template) === null || _d === void 0 ? void 0 : _d.render(file.name, res)) !== null && _e !== void 0 ? _e : "";
                        const source = (_j = (_h = (_g = (_f = this.ctx) === null || _f === void 0 ? void 0 : _f.Template) === null || _g === void 0 ? void 0 : _g.template) === null || _h === void 0 ? void 0 : _h.render(file.source, res)) !== null && _j !== void 0 ? _j : "";
                        fs_extra_1.default.ensureFileSync(path_1.default.join(process.cwd(), a));
                        fs_extra_1.default.writeFileSync(path_1.default.join(process.cwd(), a), source);
                    }));
                }
                else if (step.type === "eval") {
                    const worker = new Worker(step.code, { workerData: { num: 5 }, eval: true });
                    worker.once("message", (result) => {
                        console.log("square of 5 is :", result);
                    });
                }
            }
        });
    }
}
exports.default = Step;
