"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const fs_extra_1 = tslib_1.__importDefault(require("fs-extra"));
const constant_1 = tslib_1.__importDefault(require("../config/constant"));
const Application_1 = require("../libs/Application");
class Token extends Application_1.JKUtil {
    constructor() {
        super();
        this.load();
    }
    load() {
        try {
            this.token = fs_extra_1.default.readFileSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_TOKEN).toString();
        }
        catch (error) {
            fs_extra_1.default.ensureDirSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_ROOT);
            fs_extra_1.default.writeFileSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_TOKEN, "");
        }
    }
    /**
     * save
     */
    save(doc = "") {
        return new Promise((resolve) => {
            fs_extra_1.default.writeFileSync(constant_1.default === null || constant_1.default === void 0 ? void 0 : constant_1.default.JK_TOKEN, doc);
            this.token = doc;
            resolve(true);
        });
    }
    /**
     * clear
     */
    clear() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            yield this.save();
        });
    }
}
exports.default = Token;
