"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const chalk_1 = tslib_1.__importDefault(require("chalk"));
const latest_version_1 = tslib_1.__importDefault(require("latest-version"));
const child_process_1 = require("child_process");
const Application_1 = require("../libs/Application");
const constant_1 = tslib_1.__importDefault(require("../config/constant"));
const pack = require("../../package");
class Version extends Application_1.JKUtil {
    /**
     * update
     */
    update(version) {
        return new Promise((resolve, reject) => {
            child_process_1.exec(`npm i -g ${pack.name}@${version}`, (err, stdout, stderr) => {
                if (err) {
                    reject(err);
                }
                if (stdout) {
                    resolve(stdout);
                }
                if (stderr) {
                    resolve(stderr);
                }
            });
        });
    }
    /**
     * check
     */
    check(useTimeInterval = true) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const lastestVersionCheck = (_c = (yield ((_b = (_a = this.ctx) === null || _a === void 0 ? void 0 : _a.Config) === null || _b === void 0 ? void 0 : _b.get("lastestVersionCheck")))) !== null && _c !== void 0 ? _c : 0;
            const now = new Date() * 1;
            // do not repeat the check within one hour
            if (useTimeInterval && now - lastestVersionCheck < constant_1.default.checkVersionTimeInterval) {
                return;
            }
            (_e = (_d = this.ctx) === null || _d === void 0 ? void 0 : _d.Loading) === null || _e === void 0 ? void 0 : _e.start("staring check version");
            const lastVersion = yield latest_version_1.default(pack.name);
            (_g = (_f = this.ctx) === null || _f === void 0 ? void 0 : _f.Loading) === null || _g === void 0 ? void 0 : _g.spinner.stop();
            if (lastVersion && lastVersion !== pack.version) {
                console.log(chalk_1.default.green(`${pack.name} latest version is '${lastVersion}', current version is '${pack.version}'`));
                try {
                    yield ((_j = (_h = this.ctx) === null || _h === void 0 ? void 0 : _h.Form) === null || _j === void 0 ? void 0 : _j.confirm(`do you want to install version '${lastVersion}'`));
                    (_l = (_k = this.ctx) === null || _k === void 0 ? void 0 : _k.Loading) === null || _l === void 0 ? void 0 : _l.start("updating \n");
                    yield this.update(lastVersion);
                    (_p = (_o = (_m = this.ctx) === null || _m === void 0 ? void 0 : _m.Loading) === null || _o === void 0 ? void 0 : _o.spinner) === null || _p === void 0 ? void 0 : _p.succeed("success");
                }
                catch (error) {
                    (_s = (_r = (_q = this.ctx) === null || _q === void 0 ? void 0 : _q.Loading) === null || _r === void 0 ? void 0 : _r.spinner) === null || _s === void 0 ? void 0 : _s.fail("updating fail!");
                }
            }
            else if (!useTimeInterval) {
                console.log(chalk_1.default.green(`Current version '${pack.version}' is the latest version`));
            }
            yield ((_u = (_t = this.ctx) === null || _t === void 0 ? void 0 : _t.Config) === null || _u === void 0 ? void 0 : _u.save("lastestVersionCheck", now));
        });
    }
}
exports.default = Version;
