import { IContext } from "../types/base.type";
export interface ICommand {
    command: string;
    description?: string;
    alias?: string;
    options?: string[][];
    action?: () => void;
    providers?: any[];
    [key: string]: any;
}
export interface IApplication {
    commands: Map<string, any>;
    globalProviders: Map<string, any>;
    Command: <T extends ICommand, U>(options: T) => (target: {
        new (): U;
        [key: string]: any;
    }) => any;
    Inject: (modules: any[]) => any;
    Global: <T extends string>(module: T) => any;
    providers: (provider: FuntionType | FuntionType[]) => any;
    start: () => any;
    [key: string]: any;
}
declare type FuntionType = {
    new (): any;
};
export declare class JKModule {
    ctx: IContext | undefined;
}
export declare class JKUtil {
    ctx: IContext | undefined;
}
declare const app: IApplication;
export declare const Command: <T extends ICommand, U>(options: T) => (target: {
    new (): U;
    [key: string]: any;
}) => any;
export declare const Inject: (modules: any[]) => any;
export declare const Global: <T extends string>(module: T) => any;
export default app;
