"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rejesterProgram = void 0;
const tslib_1 = require("tslib");
const chalk_1 = tslib_1.__importDefault(require("chalk"));
const commander_1 = require("commander");
const fs_extra_1 = tslib_1.__importDefault(require("fs-extra"));
const path_1 = tslib_1.__importDefault(require("path"));
/**
 * 注册命令行
 * @param instance
 */
function rejesterProgram(instance, name) {
    const { command, action, options, description, alias, ctx } = instance;
    if (!command || !action) {
        throw new Error(`module '${name}' not found ${chalk_1.default.blue("command")}  property or ${chalk_1.default.blue("action")} method`);
    }
    const com = commander_1.program.command(command);
    if (alias) {
        com === null || com === void 0 ? void 0 : com.alias(alias);
    }
    if (description) {
        com === null || com === void 0 ? void 0 : com.description(description);
    }
    if (options) {
        for (const option of options) {
            com === null || com === void 0 ? void 0 : com.option(option[0], option[1]);
        }
    }
    if (action) {
        com === null || com === void 0 ? void 0 : com.action((a, b) => tslib_1.__awaiter(this, void 0, void 0, function* () {
            var _a;
            yield action(a, b);
            // check version when action called
            yield ((_a = ctx === null || ctx === void 0 ? void 0 : ctx.Version) === null || _a === void 0 ? void 0 : _a.check());
        }));
    }
    return instance;
}
exports.rejesterProgram = rejesterProgram;
class Exector {
    loadModules() {
        const _path = path_1.default.resolve(__dirname, "../commands");
        const files = fs_extra_1.default.readdirSync(_path);
        for (const f of files) {
            if (!f.endsWith(".d.ts")) {
                require(`${_path}/${f}`);
            }
        }
    }
    initCommands() {
        for (const c of this.commands) {
            c[1].prototype["ctx"] = this.mudules;
            const instance = new c[1]();
            rejesterProgram(instance, c[0]);
        }
    }
    initGlobal() {
        for (const c of this.$providers) {
            c.prototype["ctx"] = this.mudules;
            const instance = new c();
            instance.ctx = this.mudules;
            this.globalProviders.set(c.name, instance);
            this.mudules[c.name] = instance;
        }
    }
}
exports.default = Exector;
